blob: fe000df7ab0d3fe7c92f05072186168c12738438 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
9# TODO:
10# - use PPA repository as formula source
11# - support for spm/yum
12
13
14# Source specific env vars.
15# shopt -u dotglob
16export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
17function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020018 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030019 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
20 echo "Sourcing env variables from $f"
21 source $f
22 done
23 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020024}
25source_local_envs
26
27##########################################
28# Set defaults env variables
29
30if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
31 set -x
32 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
33fi
34
35export MAGENTA='\033[0;95m'
36export YELLOW='\033[1;33m'
37export BLUE='\033[0;35m'
38export CYAN='\033[0;96m'
39export RED='\033[0;31m'
40export NC='\033[0m' # No Color'
41
42export LC_ALL=C
43export SALT_LOG_LEVEL="--state-verbose=false -lerror"
44export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
45export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
46export BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
47export BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX stable 2016.3 }
48
49
50# salt apt repository
51test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
52which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
53#
54export APT_REPOSITORY="deb [arch=amd64] http://apt-mk.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt"
55export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt-mk.mirantis.com/public.gpg}
56
57# reclass
58export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
59
60# formula
61export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
62export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
63export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
64export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
65# essential set of formulas (known to by used on cfg01 node for most setups)
chnyda86d63b42017-08-31 10:05:00 +020066FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS memcached openssh ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020067# minimal set of formulas for salt-master bootstrap
68declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER))
69export FORMULAS_SALT_MASTER
70
71# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020072export HOSTNAME=${HOSTNAME:-`hostname -s`}
73export HOSTNAME=${HOSTNAME//.*/}
74export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020075export DOMAIN=${DOMAIN:-bootstrap.local}
76
77# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020078export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020079export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020080
81# saltstack
82BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
83BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX stable 2016.3 }
84SALT_SOURCE=${SALT_SOURCE:-pkg}
85SALT_VERSION=${SALT_VERSION:-latest}
86
87# environment
88if [ "$FORMULAS_SOURCE" == "git" ]; then
89 SALT_ENV=${SALT_ENV:-dev}
90elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
91 SALT_ENV=${SALT_ENV:-prd}
92fi
93eval $(cat /etc/*release 2> /dev/null)
94PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
95case $PLATFORM_FAMILY in
96 debian )
97 PKGTOOL="$SUDO apt-get"
98 test ${VERSION_ID//\.*/} -ge 16 && {
99 SVCTOOL=service
100 } || { SVCTOOL=service
101 }
102 ;;
103 rhel )
104 PKGTOOL="$SUDO yum"
105 test ${VERSION_ID//\.*/} -ge 7 && {
106 SVCTOOL=systemctl
107 } || { SVCTOOL=service
108 }
109 ;;
110esac
111
112export PLATFORM_FAMILY
113export PKGTOOL
114export SVCTOOL
115
116##########################################
117# FUNCTIONS
118
119log_info() {
120 echo -e "${YELLOW}[INFO] $* ${NC}"
121}
122
123log_warn() {
124 echo -e "${MAGENTA}[WARN] $* ${NC}"
125}
126
Petr Michalec24b30e82017-08-21 10:59:18 +0200127log_debug() {
128 echo -e "${CYAN}[WARN] $* ${NC}"
129}
130
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200131log_err() {
132 echo -e "${RED}[ERROR] $* ${NC}" >&2
133}
134
135configure_pkg_repo()
136{
137
138 case $PLATFORM_FAMILY in
139 debian)
140 if [ -n "$APT_REPOSITORY_PPA" ]; then
141 which add-apt-repository || $SUDO apt-get install -y software-properties-common
142 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
143 else
144 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/bootstrap.list >/dev/null
145 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
146 fi
147 $SUDO apt-get clean
148 $SUDO apt-get update
149 ;;
150 rhel)
151 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
152 $SUDO yum clean all
153 ;;
154 esac
155
156}
157
158_atexit() {
159 RETVAL=$?
160 trap true INT TERM EXIT
161
162 if [ $RETVAL -ne 0 ]; then
163 log_err "Execution failed"
164 else
165 log_info "Execution successful"
166 fi
167 return $RETVAL
168}
169
170retry() {
171 local tries
172 if [[ $1 =~ ^[0-9]+$ ]]; then
173 tries=$1; shift
174 else
175 tries=3
176 fi
177 for i in $(seq 1 $tries); do
178 "$@" && return 0 || sleep $i
179 done
180 return 1
181}
182
183function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200184 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200185 # No reclass at all, clone from given address
186 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
187 if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then
188 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
189 cd ${RECLASS_ROOT}
190 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD
191 cd -
192 else
193 git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
194 fi;
195 fi;
Petr Michaleca361d4e2017-09-08 11:38:16 +0200196 if [ ! -d ${RECLASS_ROOT}/classes -o ! -d ${RECLASS_ROOT}/nodes ]; then
197 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
198 ls -Rla ${RECLASS_ROOT}
199 exit 1
200 fi;
201 $SUDO mkdir -p $RECLASS_ROOT/classes/service
202 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200203}
204
205
206##########################################
207# Main calls
208
Petr Michalecda014202017-08-18 11:26:07 +0200209system_config_ssh_conf() {
210 for conf in ~/.ssh/config /root/.ssh/config; do
211 $SUDO mkdir -p $(dirname $conf)
212 if ! grep StrictHostKeyChecking $conf; then
213 # this should be used only in CI environment
214 echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null
215 fi
216 done
217 if ! grep github.com ~/.ssh/known_hosts; then
218 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
219 fi
220}
221
222system_config_salt_modules_prereq() {
223 # salt-formulas custom modules dependencies, etc:
224 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
225}
226
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200227system_config_minion() {
228 log_info "System configuration salt minion"
229}
230
231system_config_master() {
232 log_info "System configuration salt master"
233
Petr Michalecda014202017-08-18 11:26:07 +0200234 system_config_salt_modules_prereq
235 system_config_ssh_conf
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200236
Petr Michalecda014202017-08-18 11:26:07 +0200237 if ! grep '127.0.1.2.*salt' /etc/hosts; then
238 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
239 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200240
241 which reclass || $SUDO $PKGTOOL install -y reclass
242
243 which reclass-salt || {
244 test -e /usr/share/reclass/reclass-salt && {
245 ln -fs /usr/share/reclass/reclass-salt /usr/bin
246 }
247 }
248}
249
250configure_salt_master()
251{
252
253 echo "Configuring salt-master ..."
254
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200255 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
256 IGNORE_CLASS_NOTFOUND="ignore_class_notfound: True"
257 fi
258
Petr Michalecdd1a0472017-09-06 19:27:24 +0200259 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200260 if [ -n "$RECLASS_SOURCE_PATH" ]; then
261 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
262 else
263 RECLASS_SOURCE_PATH=""
264 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200265
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200266 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
267 cat <<-EOF > /etc/salt/master.d/master.conf
268 file_roots:
269 base:
270 - /usr/share/salt-formulas/env
271 prd:
272 - /srv/salt/env/prd
273 dev:
274 - /srv/salt/env/dev
275 pillar_opts: False
276 open_mode: True
277 reclass: &reclass
278 storage_type: yaml_fs
279 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200280 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200281 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200282 ext_pillar:
283 - reclass: *reclass
284 master_tops:
285 reclass: *reclass
286EOF
287
288 echo "Configuring reclass ..."
289
290 [ ! -d /etc/reclass ] && mkdir /etc/reclass
291 cat <<-EOF > /etc/reclass/reclass-config.yml
292 storage_type: yaml_fs
293 pretty_print: True
294 output: yaml
295 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200296 ${IGNORE_CLASS_NOTFOUND}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200297EOF
298
299 clone_reclass
300 # override some envs from cluster level *.env, use with care
301 source_local_envs
302
303 cd ${RECLASS_ROOT}
304 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
305 # Possibly subrepo checkout needed
306 git submodule update --init --recursive
307 fi
308
Petr Michalec212cc6a2017-08-17 21:39:40 +0200309 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200310 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
311
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200312 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200313 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200314 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200315 log_warn "Salt Master node specification has not been found in model."
316 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200317 cat <<-EOF > ${CONFIG}
318 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200319 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200320 parameters:
321 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200322 single_address: ${MASTER_IP:-$MASTER_HOSTNAME}
323 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200324 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200325 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
326 reclass_data_revision: ${RECLASS_BRANCH:-master}
327 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200328 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200329 linux_system_codename: ${DISTRIB_CODENAME}
330 cluster_name: ${CLUSTER_NAME}
331 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200332 linux:
333 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200334 name: ${HOSTNAME:-cfg01}
335 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200336 # ########
337EOF
338
339 if [ "$SALT_VERSION" == "latest" ]; then
340 VERSION=""
341 else
342 VERSION="version: $SALT_VERSION"
343 fi
344
345 cat <<-EOF >> ${CONFIG}
346 salt:
347 master:
348 accept_policy: open_mode
349 source:
350 engine: $SALT_SOURCE
351 $VERSION
352 minion:
353 source:
354 engine: $SALT_SOURCE
355 $VERSION
356 # ########
357 # vim: ft=yaml sw=2 ts=2 sts=2
358EOF
359 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200360
361 log_debug "Salt Master node config yaml:"
362 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200363}
364
365configure_salt_minion()
366{
367 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
368 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200369 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200370 id: $MINION_ID
371 EOF
372}
373
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200374install_reclass()
375{
376 VERSION=${1:-$RECLASS_VERSION}
377 VERSION=${VERSION:-master}
378 # tries to replace all local version system version
379 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michaleca2f351c2017-09-07 17:37:44 +0200380 sudo -H pip install --upgrade --force-reinstall -I \
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200381 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
382 done
383}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200384
385install_salt_master_pkg()
386{
387 echo -e "\nPreparing base OS repository ...\n"
388
389 configure_pkg_repo
390
391 echo -e "\nInstalling salt master ...\n"
392
393 case $PLATFORM_FAMILY in
394 debian)
395 $SUDO apt-get install -y git
396 which reclass || $SUDO apt install -qqq -y reclass
397 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
398 ;;
399 rhel)
400 yum install -y git
401 which reclass || $SUDO yum install -y reclass
402 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
403 ;;
404 esac
405
406 which reclass-salt || {
407 test -e /usr/share/reclass/reclass-salt && {
408 ln -fs /usr/share/reclass/reclass-salt /usr/bin
409 }
410 }
411
412 configure_salt_master
413
414 echo -e "\nRestarting services ...\n"
415 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
416 $SVCTOOL salt-master restart
417}
418
419install_salt_master_pip()
420{
421 echo -e "\nPreparing base OS repository ...\n"
422
423 case $PLATFORM_FAMILY in
424 debian)
425 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
426 which reclass || $SUDO apt-get install -y reclass
427 ;;
428 rhel)
429 $SUDO yum install -y git
430 which reclass || $SUDO yum install -y reclass
431 ;;
432 esac
433
434 echo -e "\nInstalling salt master ...\n"
435 # TODO: replace with saltstack bootstrap script
436
437 if [ "$SALT_VERSION" == "latest" ]; then
438 pip install salt
439 else
440 pip install salt==$SALT_VERSION
441 fi
442
443 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
444 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
445
446 which reclass-salt || {
447 test -e /usr/share/reclass/reclass-salt && {
448 ln -fs /usr/share/reclass/reclass-salt /usr/bin
449 }
450 }
451
452 configure_salt_master
453
454 echo -e "\nRestarting services ...\n"
455 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
456 $SVCTOOL salt-master restart
457}
458
459
460
461install_salt_minion_pkg()
462{
463
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200464 echo -e "\nInstalling salt minion ...\n"
465
466 case $PLATFORM_FAMILY in
467 debian)
468 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
469 ;;
470 rhel)
471 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
472 ;;
473 esac
474
475
476 configure_salt_minion
477
478 $SVCTOOL salt-minion restart
479}
480
481install_salt_minion_pip()
482{
483 echo -e "\nInstalling salt minion ...\n"
484
485 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
486 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
487
488 configure_salt_minion
489 $SVCTOOL salt-minion restart
490}
491
492
493install_salt_formula_pkg()
494{
495 configure_pkg_repo
496
497 case $PLATFORM_FAMILY in
498 debian)
499 echo "Configuring necessary formulas ..."
500
501 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
502 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
503 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
504 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
505 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
506 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
507 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
508 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
509 exit 1
510 fi
511 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
512 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
513 done
514 ;;
515 rhel)
516 # TODO
517 ;;
518 esac
519
520 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
521 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
522}
523
524install_salt_formula_git()
525{
526 echo "Configuring necessary formulas ..."
527
528 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
529 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
530 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
531 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
532 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
533 _BRANCH=${FORMULAS_BRANCH}
534 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
535 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
536 # Fallback to the master branch if the branch doesn't exist for this repository
537 _BRANCH=master
538 fi
539 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
540 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
541 exit 1
542 fi
543 } || {
544 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
545 git fetch origin/${_BRANCH} || git fetch --all
546 git checkout ${_BRANCH} && git pull || git pull;
547 cd -
548 }
549 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
550 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
551 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
552 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
553 done
554
555 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
556 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
557}
558
559
560saltmaster_bootstrap() {
561
562 log_info "Salt master setup"
563 test -n "$MASTER_HOSTNAME" || exit 1
564
565 clone_reclass
566 # override some envs from cluster level *.env, use with care
567 source_local_envs
568
569 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
570 pkill -9 salt-minion
571 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Petr Michaleca7de6df2017-08-31 12:16:57 +0200572 export MASTER_IP=localhost
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200573 export MINION_ID=${MASTER_HOSTNAME}
574 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
575 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
576 fi
577 # call local "setup() master"
578 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
579 if ! setup master; then
580 #cat /tmp/salt-master-setup.log
581 log_err "salt master setup() failed."
582 exit 1
583 else
584 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
585 fi
586 }
587
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200588 if [[ $RECLASS_VERSION =~ ^(dev|devel|master)$ ]]; then
Petr Michalec2f9a35b2017-09-07 17:08:06 +0200589 log_warn "Install development version of reclass"
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200590 install_reclass ${RECLASS_VERSION/dev*/master}
591 fi
592
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200593 log_info "Re/starting salt services"
594 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
595 pkill -9 salt-minion
596 sleep 1
597 $SUDO service salt-master restart
598 $SUDO service salt-minion restart
599 sleep 10
600}
601
602# Init salt master
603saltmaster_init() {
604
605 log_info "Runing saltmaster states"
606 test -n "$MASTER_HOSTNAME" || exit 1
607
608 set -e
609 $SUDO salt-call saltutil.sync_all >/dev/null
610
611 # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration
612 # (ie: with linux, git, salt formulas)
613
614 #log_info "Verify SaltMaster, before salt-master is fully initialized"
615 #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then
616 # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar;
617 #fi
618
Petr Michalecda014202017-08-18 11:26:07 +0200619
620 # workarond isolated and not fully bootstraped environments
Petr Michalec571d6b82017-08-18 13:25:24 +0200621 PILLAR='{"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}'"}}}}, "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200622
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200623 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200624 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200625 log_err "State salt.master.env failed, keep your eyes wide open."
626 fi
627
628 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200629 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200630 # Note: sikp reclass data dir states
631 # in order to avoid pull from configured repo/branch
632
633 # Revert temporary SaltMaster minimal configuration, if any
634 pushd $RECLASS_ROOT
635 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
636 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200637 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200638 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
639 git checkout -- $RECLASS_ROOT/nodes || true
640 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
641 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200642 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200643 log_err "State salt.master.env failed, keep your eyes wide open."
644 fi
645 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200646 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200647 fi
648 popd
649
Petr Michalecda014202017-08-18 11:26:07 +0200650 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
651 log_info "State: salt.master.service"
Petr Michalec7f3e7e72017-08-18 13:49:24 +0200652 $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalecda014202017-08-18 11:26:07 +0200653
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200654 log_info "State: salt.master.storage.node"
655 set +e
Petr Michaleca5141342017-08-16 12:55:20 +0200656 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200657 $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
658 ret=$?
659 set -e
660
661 if [[ $ret -eq 2 ]]; then
662 log_err "State reclass.storage.node failed with exit code 2 but continuing."
663 elif [[ $ret -ne 0 ]]; then
664 log_err "State reclass.storage.node failed with exit code $ret"
665 exit 1
666 fi
667
668 log_info "Re/starting salt services"
669 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalec5951ff42017-09-07 18:29:53 +0200670 $SUDO service salt-master restart >/dev/null
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200671 $SUDO service salt-minion restart >/dev/null
672 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
673
674 verify_salt_master
675 set +e
676
677}
678
679
680function verify_salt_master() {
681 set -e
682
683 log_info "Verify Salt master"
684 test -n "$MASTER_HOSTNAME" || exit 1
685
686 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200687 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
688 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200689 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
690 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
691 $SUDO salt-call --no-color grains.items
692 $SUDO salt-call --no-color pillar.data
693 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200694 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200695 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
696 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
697 exit 1
698 fi
699}
700
701function verify_salt_minion() {
702 set -e
703 node=$1
704 log_info "Verifying ${node}"
705 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
706 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
707 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
708 fi
709 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
710 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
711 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
712 exit 1
713 fi
714 fi
715}
716
717function verify_salt_minions() {
718 #set -e
719 NODES=$(find $RECLASS_ROOT/nodes/ -name "*.yml" | grep -v "cfg")
720 log_info "Verifying minions: $(echo ${NODES}|xargs)"
721
722 # Parallel
723 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
724 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
725
726 function filterFails() {
727 grep -v '/grains' | tee -a $1 | tail -n20
728 }
729
730 log_info "Verify nodes"
731 passed=0
732 for node in ${NODES}; do
733 node=$(basename $node .yml)
734
735 # filter first in cluster.. ctl-01, mon-01, etc..
736 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
737 verify_salt_minion ${node} || continue
738 else
739 echo Skipped $node.
740 fi
741 passed=$(($passed+1))
742 done
743 # fail on failures
744 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
745 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
746 test ! $passed -lt $total || {
747 tail -n50 /tmp/*.pillar_verify
748 return 1
749 }
750}
751
752
753
754##########################################
755# To install salt master/minon
756
757function install() {
758 setup $@
759}
760
761function setup() {
762 # CLI
763 while [ x"$1" != x"" ]; do
764 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
765
766 case $1 in
767 master )
768 install_salt_master_$SALT_SOURCE
769 install_salt_minion_$SALT_SOURCE
770 install_salt_formula_$FORMULAS_SOURCE
771 ;;
772 minion )
773 install_salt_minion_$SALT_SOURCE
774 ;;
775 esac
776 shift
777 done
778 echo DONE
779}
780
781function bootstrap() {
782 log_info "Bootstrap & verification of SaltMaster and configured minions."
783 trap _atexit INT TERM EXIT
784
785 system_config_master
786 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200787 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200788 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200789}
790
791function default() {
792 bootstrap $@
793}
794
795
796##########################################
797[[ "$0" != "$BASH_SOURCE" ]] || {
798# unless file is being sourced
799 default $@
800}